/*
	display doscall name, arguments, result code
	( called from New_handler )

	Copyright (C) 1991 K.Abe

	Patch for Human3.02 by Tachibana Eriko
*/

#include <stdio.h>
#include <unistd.h>
#include "trace.h"
#include "error.inc"

#define CSRX	(unsigned short *)(0x974)
#define WAIT	(int *)(0x1cae)


static	void	indent( void );

static	char	*Formatted_string;
static	int	exec_level = -1;
static	int	Doscall_nestlevel = 0;
static	char	Last_instruction_not_return = 0;
static	char	exec_flag = 0;
static	char	Flush_flag = 1;


extern void display1( int callnum , void *arg )
{
    callnum &= 0xff;

    if( Flush_flag == 0 )
    {
	/* ċAInR[̕Ԓl͎̃̕R[ŕ\ */

	if( Option_A_flag || 1 == exec_flag )
	{
	    indent();
	    fputs( Formatted_string , Stream );
	}

	if( Last_instruction_not_return )
	{
	    fputs( "=?\n" , Stream );

	    if( ! Option_A_flag && 1 == exec_flag && 0 == Doscall_nestlevel )
		    exec_flag = 2;
	    else
		Doscall_nestlevel--;

	    if( Option_A_flag || 1 == exec_flag )
	    {
		indent();
		fprintf( Stream , "}=%d\n" , *WAIT );
	    }
	}
	else
	{
	    if( Option_A_flag || 1 == exec_flag )
		fputs( "={\n" , Stream );
	    Doscall_nestlevel++;
	}
    }

    Formatted_string = Format_output( callnum , arg );

    Last_instruction_not_return = ( callnum == 0
				 || callnum == 0x4c
				 || callnum == 0x31 );

    if( callnum == 0x4b && ( *(short *)arg == 0
			  || *(short *)arg == 4 ) )
	exec_level = Doscall_nestlevel;

    if( Option_A_flag || 1 == exec_flag )
	Count++;

    if( isatty( fileno( Stream ) ) )
	fflush( Stream );

    Flush_flag = 0; /* DOSR[s 0 */
}


extern void display2( int result )
{
    if( Flush_flag )
	Doscall_nestlevel--;

    if( Option_A_flag || 1 == exec_flag )
    {
	indent();

	if( Flush_flag )
	    putc( '}' , Stream );
	else
	    fputs( Formatted_string , Stream );

	fprintf( Stream , "=%d" , result );
	if( (unsigned long)result >= 10 )
	    fprintf( Stream , "(%#x)" , result );

	if( result < 0 )
	    if( ERROR_NUMBER_MIN <= result || result == -80 )
		fprintf( Stream , "(%s)" , Human_error_message[ (result == -80) ? 0 : -result ] );

	putc( '\n' , Stream );
    }

    if( exec_level == Doscall_nestlevel && result >= 0 )
    {
	if( Option_A_flag || 1 == exec_flag )
	{
	    indent();
	    fputs( "EXEC()={\n" , Stream );
	}
	if( ! Option_A_flag && 0 == exec_flag )
	    exec_flag = 1;
	else
	    Doscall_nestlevel++;

	exec_level = -1;
    }

    Flush_flag = 1;
}


static void indent()
{
    int	i;

    if( isatty( fileno( Stream ) ) )
    {
	fflush( Stream );
	if( *CSRX != 0 )
	    putc( '\n' , Stream );
    }

    for( i = 0 ; i < Doscall_nestlevel ; i++ )
    {
	putc( ' ' , Stream );
	putc( ' ' , Stream );
    }
//	fprintf( Stream , "<%d>" , Doscall_nestlevel );
}


/* EOF */
